package org.xbib.jdbc.pool;

import org.xbib.jdbc.pool.api.XbibDataSource;
import org.xbib.jdbc.pool.api.XbibDataSourceListener;
import org.xbib.jdbc.pool.api.XbibDataSourceProvider;
import org.xbib.jdbc.pool.api.configuration.XbibDataSourceConfiguration;
import static org.xbib.jdbc.pool.api.configuration.XbibDataSourceConfiguration.DataSourceImplementation.XBIB;
import static org.xbib.jdbc.pool.api.configuration.XbibDataSourceConfiguration.DataSourceImplementation.XBIB_POOLLESS;

public final class DataSourceProvider implements XbibDataSourceProvider {

    public DataSourceProvider() {
    }

    @Override
    public XbibDataSource getDataSource(XbibDataSourceConfiguration config, XbibDataSourceListener... listeners) {
        return config.dataSourceImplementation() == XBIB || config.dataSourceImplementation() == XBIB_POOLLESS ? new DataSource(config, listeners) : null;
    }
}
