package org.xbib.jdbc.pool;

import org.xbib.jdbc.pool.api.XbibDataSourceMetrics;

public interface MetricsRepository extends XbibDataSourceMetrics {

    default long beforeConnectionCreation() {
        return 0;
    }

    default void afterConnectionCreation(long timestamp) {
    }

    default long beforeConnectionAcquire() {
        return 0;
    }

    default void afterConnectionAcquire(long timestamp) {
    }

    default void afterConnectionReturn() {
    }

    default void afterLeakDetection() {
    }

    default void afterConnectionInvalid() {
    }

    default void afterConnectionFlush() {
    }

    default void afterConnectionReap() {
    }

    default void afterConnectionDestroy() {
    }

    final class EmptyMetricsRepository implements MetricsRepository {

        public EmptyMetricsRepository() {
        }

        @Override
        public String toString() {
            return "Metrics Disabled";
        }
    }
}
