package org.xbib.jdbc.pool.api;

import org.xbib.jdbc.pool.api.configuration.XbibDataSourceConfiguration;

/**
 * An interface for providers of XbibDataSource.
 */
public interface XbibDataSourceProvider {

    /**
     * Factory method for XbibDataSource. This method must return null if it can't create an XbibDataSource based on the supplied configuration.
     */
    XbibDataSource getDataSource(XbibDataSourceConfiguration configuration, XbibDataSourceListener... listeners);
}
