package org.xbib.jdbc.pool.api.cache;

/**
 * Contract for objects that can be acquired.
 */
public interface Acquirable {

    /**
     * Attempts to acquire this object.
     *
     * @return true on successful object acquisition, false otherwise.
     */
    boolean acquire();

    /**
     * This method signals if the object can't be acquired in future calls to acquire().
     *
     * @return true if this object can eventually be acquired in the future.
     */
    boolean isAcquirable();
}
