package org.xbib.jdbc.pool.api.exceptionsorter;

import java.sql.SQLException;
import org.xbib.jdbc.pool.api.configuration.XbibConnectionPoolConfiguration.ExceptionSorter;

/**
 * Exception sorter for MySQL / MariaDB databases.
 */
public class MySQLExceptionSorter implements ExceptionSorter {

    public MySQLExceptionSorter() {
    }

    @Override
    @SuppressWarnings("MagicNumber")
    public boolean isFatal(SQLException e) {
        if (e.getSQLState() != null && e.getSQLState().startsWith("08")) {
            return true;
        }
        return switch (e.getErrorCode()) {
            case 1040, 1042, 1043, 1047, 1081, 1129, 1130, 1045, 1004, 1005, 1015, 1021, 1041, 1037, 1038 -> true;
            // All other errors
            default -> false;
        };
    }
}
