package org.xbib.jdbc.pool.api.exceptionsorter;

import java.sql.SQLException;
import org.xbib.jdbc.pool.api.configuration.XbibConnectionPoolConfiguration.ExceptionSorter;

/**
 * Exception sorter for PostgreSQL databases.
 */
public class PostgreSQLExceptionSorter implements ExceptionSorter {

    public PostgreSQLExceptionSorter() {
    }

    @Override
    public boolean isFatal(SQLException e) {
        String sqlState = e.getSQLState();
        return sqlState != null && sqlState.startsWith("08"); // Class 08 — Connection Exception
    }
}
