package org.xbib.jdbc.pool.api.exceptionsorter;

import java.sql.SQLException;
import java.util.Locale;
import org.xbib.jdbc.pool.api.configuration.XbibConnectionPoolConfiguration.ExceptionSorter;

/**
 * Exception sorter for Sybase databases.
 */
public class SybaseExceptionSorter implements ExceptionSorter {

    public SybaseExceptionSorter() {
    }

    @Override
    public boolean isFatal(SQLException e) {
        String errorText = (e.getMessage()).toUpperCase(Locale.US);

        //     ERR_CONNECTION_DEAD              ERR_IOE_KILLED_CONNECTION        CONNECTION CLOSED
        return errorText.contains("JZ0C0") || errorText.contains("JZ0C1") || errorText.contains("JZ006");
    }
}
