package org.xbib.jdbc.pool.api.security;

import java.security.Principal;
import java.util.Properties;

/**
 * A string that identifies an user account.
 */
public class NamePrincipal implements Principal {

    private final String name;

    public NamePrincipal(String name) {
        this.name = name;
    }

    public NamePrincipal(char[] name) {
        this.name = new String(name);
    }

    public String getName() {
        return name;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (!(o instanceof Principal p)) {
            return false;
        }
        return name == null ? p.getName() == null : name.contentEquals(p.getName());
    }

    @Override
    public int hashCode() {
        return name == null ? 7 : name.hashCode();
    }

    @Override
    public String toString() {
        return name;
    }

    public Properties asProperties() {
        Properties properties = new Properties();
        properties.setProperty("user", name);
        return properties;
    }
}
