package org.xbib.jdbc.pool.api.security;

import java.util.Properties;

/**
 * Credential that holds a secret string of characters to be used for authentication.
 */
public class SimplePassword {

    private final String word;

    public SimplePassword(String password) {
        word = password;
    }

    public SimplePassword(char[] password) {
        word = new String(password);
    }

    public String getWord() {
        return word;
    }

    public Properties asProperties() {
        Properties properties = new Properties();
        properties.setProperty("password", word);
        return properties;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (!(o instanceof SimplePassword that)) {
            return false;
        }

        return word == null ? that.word == null : word.contentEquals(that.word);
    }

    @Override
    public int hashCode() {
        return word == null ? 7 : word.hashCode();
    }

    @Override
    public String toString() {
        return "*** masked ***";
    }
}
