package org.xbib.jdbc.pool.api.security;

import java.security.Principal;
import java.util.Properties;

/**
 * Handles objects of type {@link NamePrincipal}, {@link SimplePassword} and {@link Principal}
 */
public class XbibDefaultSecurityProvider implements XbibSecurityProvider {

    public XbibDefaultSecurityProvider() {
    }

    @Override
    @SuppressWarnings("InstanceofConcreteClass")
    public Properties getSecurityProperties(Object securityObject) {
        if (securityObject instanceof NamePrincipal) {
            return ((NamePrincipal) securityObject).asProperties();
        }
        if (securityObject instanceof SimplePassword) {
            return ((SimplePassword) securityObject).asProperties();
        }
        if (securityObject instanceof Principal) {
            Properties properties = new Properties();
            properties.setProperty("user", ((Principal) securityObject).getName());
            return properties;
        }
        return null;
    }
}
