package org.xbib.jdbc.pool.api.security;

import java.util.Properties;

/**
 * Interface to be implemented in order to extend with custom types of authentication.
 */
public interface XbibSecurityProvider {

    /**
     * Converts a custom principal / credential objects to properties to be passed to the JDBC driver.
     *
     * @return null if not capable of handle the security object, otherwise return a {@link Properties} object even if empty.
     */
    Properties getSecurityProperties(Object securityObject);
}
