package org.xbib.jdbc.pool.util;

import java.util.concurrent.atomic.LongAdder;
import java.util.concurrent.locks.AbstractQueuedLongSynchronizer;

@SuppressWarnings("serial")
public final class XbibSynchronizer extends AbstractQueuedLongSynchronizer {

    private final LongAdder counter = new LongAdder();

    @Override
    protected boolean tryAcquire(long value) {
        return counter.longValue() > value;
    }

    @Override
    protected boolean tryRelease(long releases) {
        counter.add(releases);
        return true;
    }

    public long getStamp() {
        return counter.sum();
    }

    public void releaseConditional() {
        if (hasQueuedThreads()) {
            release(1);
        }
    }
}
